Files
gem5/util/github-runners-vagrant/provision_root.sh
Bobby R. Bruce b2d13ee63a util: Remove action runner add-apt-repo git-core/ppa (#856)
We were having some difficulty on a server running this
`apt-apt-repository` command due to suspected firewall issues. On
further inspection is appear to be superfluous as git can be obtained
easily through `apt-get` without adding this repository.
2024-02-08 12:13:12 -08:00

95 lines
3.4 KiB
Bash

#!/usr/bin/env bash
# Copyright (c) 2023 The Regents of the University of California
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met: redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer;
# redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution;
# neither the name of the copyright holders nor the names of its
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# fail on unset variables and command errors
set -eu -o pipefail # -x: is for debugging
apt-get update
apt-get upgrade -y
apt-get install -y \
software-properties-common \
bash \
build-essential \
clang-format \
git \
git-lfs \
jq \
libffi-dev \
libssl-dev \
nkf \
python3 \
python3-dev \
python3-pip \
python3-venv \
shellcheck \
tree \
wget \
yamllint \
zstd \
jq \
apt-transport-https ca-certificates \
curl \
gnupg \
lsb-release \
cpu-checker
# Install docker
apt-get install -y apt-transport-https ca-certificates curl gnupg lsb-release
curl -fsSL https://download.docker.com/linux/ubuntu/gpg | gpg --dearmor -o /usr/share/keyrings/docker-archive-keyring.gpg
echo "deb [arch=amd64 signed-by=/usr/share/keyrings/docker-archive-keyring.gpg] https://download.docker.com/linux/ubuntu $(lsb_release -cs) stable" | tee /etc/apt/sources.list.d/docker.list > /dev/null
apt-get update -y
apt-get install -y docker-ce docker-ce-cli containerd.io
# Add the Vagrant user to the docker group.
# Note: The VM needs rebooted for this to take effect. `newgrp docker` doesn't
# work.
usermod -aG docker vagrant
kvm-ok
kvm_ok_status=$?
# `kvm-ok` will return a exit zero if the machine supports KVM, and non-zero
# otherwise. If the machine support KVM, let's enable it.
if [[ ${kvm_ok_status} == 0 ]]; then
apt install -y qemu-kvm \
virt-manager \
libvirt-daemon-system virtinst \
libvirt-clients bridge-utils && \
sudo systemctl enable --now libvirtd && \
sudo systemctl start libvirtd && \
usermod -aG kvm vagrant && \
usermod -aG libvirt vagrant
fi
# Cleanup
apt-get autoremove -y
# Resize the root partition to fill up all the free size on the disk
lvextend -l +100%FREE $(df / --output=source | sed 1d)
resize2fs $(df / --output=source | sed 1d)